/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 614:  /* *combiner.md:1222 */
    case 613:  /* *combiner.md:1209 */
    case 612:  /* *combiner.md:1199 */
    case 611:  /* *combiner.md:1186 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 610:  /* *combiner.md:1177 */
    case 608:  /* *combiner.md:1155 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 604:  /* *iorsi3_ashift_16_ashift_24_mem */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 602:  /* *iorsi2_and_1_lshiftrt_1_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 601:  /* *iorsi2_and_1_lshiftrt_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 605:  /* *addsi3_shift */
    case 600:  /* *iorsi3_shift */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 599:  /* *iorsi3_and_lshiftrt_9_sb_clobber_flags */
    case 598:  /* *iorsi3_and_lshiftrt_9_sb */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 597:  /* *iorsi3_and_lshiftrt_n_sb_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 595:  /* *iorsi3_zero_extract_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 594:  /* *iorsi3_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 593:  /* *iorsi3_and_lshiftrt_clobber_flags */
    case 591:  /* *iorsi3_and_ashift_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 592:  /* *iorsi3_and_lshiftrt */
    case 590:  /* *iorsi3_and_ashift */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 582:  /* *iorsi3_two_qi_zext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      break;

    case 579:  /* *iorhi3_two_qi_mem_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      break;

    case 585:  /* *iorsi3_two_qi_sext */
    case 578:  /* *iorhi3_two_qi_mem */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 571:  /* *ixorsi3_lshiftrt_16_clobber_flags */
    case 569:  /* *ixorsi3_ashift_16_clobber_flags */
    case 567:  /* *ixorsi3_zext_hi_clobber_flags */
    case 565:  /* *ixorsi3_zext_qi_clobber_flags */
    case 563:  /* *ixorhi3_zext_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 570:  /* *ixorsi3_lshiftrt_16 */
    case 568:  /* *ixorsi3_ashift_16 */
    case 566:  /* *ixorsi3_zext_hi */
    case 564:  /* *ixorsi3_zext_qi */
    case 562:  /* *ixorhi3_zext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 556:  /* *andsi3_lshiftrt_n_sb */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 554:  /* *andsi3_ashift_n_lower */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 551:  /* *extzv_16_8_clobber_flags */
    case 550:  /* *extzv_16_8 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 545:  /* *insv_si_8_8_lshiftrt_8_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 544:  /* *insv_si_8_8_lshiftrt_8 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 541:  /* *insv_si_1_n_lshiftrt_16_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 540:  /* *insv_si_1_n_lshiftrt_16 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 539:  /* *insv_si_1_n_lshiftrt_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 538:  /* *insv_si_1_n_lshiftrt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 535:  /* bfst_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 2));
      break;

    case 534:  /* bfst */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 533:  /* bfld_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      break;

    case 532:  /* bfld */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 531:  /* *bitfield.md:275 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 530:  /* *bitfield.md:254 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 1));
      break;

    case 529:  /* *bitfield.md:242 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 528:  /* *bitfield.md:225 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 1));
      break;

    case 537:  /* *insv_si_1_n_clobber_flags */
    case 527:  /* *bitfield.md:167 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 536:  /* *insv_si_1_n */
    case 526:  /* *bitfield.md:155 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 523:  /* *extzv_1_r_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      break;

    case 522:  /* *extzv_1_r */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 525:  /* *extzv_1_r_inv_clobber_flags */
    case 521:  /* *bitfield.md:34 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      break;

    case 524:  /* *extzv_1_r_inv */
    case 520:  /* *bitfield.md:18 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 513:  /* *shiftsi_clobber_flags */
    case 512:  /* *shiftsi_clobber_flags */
    case 511:  /* *shiftsi_clobber_flags */
    case 510:  /* *shiftsi */
    case 509:  /* *shiftsi */
    case 508:  /* *shiftsi */
    case 498:  /* *shifthi_clobber_flags */
    case 497:  /* *shifthi_clobber_flags */
    case 496:  /* *shifthi_clobber_flags */
    case 495:  /* *shifthi */
    case 494:  /* *shifthi */
    case 493:  /* *shifthi */
    case 483:  /* *shiftqi_clobber_flags */
    case 482:  /* *shiftqi_clobber_flags */
    case 481:  /* *shiftqi_clobber_flags */
    case 480:  /* *shiftqi */
    case 479:  /* *shiftqi */
    case 478:  /* *shiftqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 468:  /* *shiftrotate.md:132 */
    case 467:  /* *shiftrotate.md:132 */
    case 466:  /* *shiftrotate.md:132 */
    case 459:  /* *shiftrotate.md:82 */
    case 458:  /* *shiftrotate.md:82 */
    case 457:  /* *shiftrotate.md:82 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[2] = 1;
      break;

    case 465:  /* *shiftrotate.md:114 */
    case 464:  /* *shiftrotate.md:114 */
    case 463:  /* *shiftrotate.md:114 */
    case 456:  /* *shiftrotate.md:64 */
    case 455:  /* *shiftrotate.md:64 */
    case 454:  /* *shiftrotate.md:64 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 462:  /* *shiftrotate.md:103 */
    case 461:  /* *shiftrotate.md:103 */
    case 460:  /* *shiftrotate.md:103 */
    case 453:  /* *shiftrotate.md:53 */
    case 452:  /* *shiftrotate.md:53 */
    case 451:  /* *shiftrotate.md:53 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 428:  /* return_h8sx */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 427:  /* stm_h8300sx */
    case 426:  /* ldm_h8300sx */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 415:  /* tablejumpsi */
    case 414:  /* tablejumphi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 412:  /* *jumpcall.md:166 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 411:  /* *jumpcall.md:146 */
    case 410:  /* *jumpcall.md:146 */
    case 409:  /* *jumpcall.md:146 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 408:  /* *branch_1_false */
    case 407:  /* *branch_1_false */
    case 406:  /* *branch_1_false */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 405:  /* *branch_1 */
    case 404:  /* *branch_1 */
    case 403:  /* *branch_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 402:  /* *branch */
    case 401:  /* *branch */
    case 400:  /* *branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 430:  /* monitor_prologue */
    case 429:  /* *return_1 */
    case 399:  /* nop */
      break;

    case 340:  /* *andorsi3_shift_8_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      break;

    case 339:  /* *andorsi3_shift_8 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 338:  /* *andorsi3_clobber_flags */
    case 337:  /* *andorhi3_clobber_flags */
    case 336:  /* *andorqi3_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      break;

    case 335:  /* *andorsi3 */
    case 334:  /* *andorhi3 */
    case 333:  /* *andorqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 327:  /* divmodhi4_clobber_flags */
    case 326:  /* divmodhi4 */
    case 325:  /* udivmodhi4_clobber_flags */
    case 324:  /* udivmodhi4 */
    case 323:  /* divmodqi4_clobber_flags */
    case 322:  /* divmodqi4 */
    case 321:  /* udivmodqi4_clobber_flags */
    case 320:  /* udivmodqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 311:  /* *multiply.md:250 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 310:  /* *multiply.md:239 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      break;

    case 308:  /* smulsi3_highpart_clobber_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      break;

    case 309:  /* umulsi3_highpart */
    case 307:  /* smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 298:  /* *mulhisi3_cczn */
    case 292:  /* *mulqihi3_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 587:  /* *iorsi3_w_clobber_flags */
    case 584:  /* *iorsi3_e2f_clobber_flags */
    case 581:  /* *iorsi3_two_hi_clobber_flags */
    case 577:  /* *iorhi3_two_qi_clobber_flags */
    case 561:  /* *addsi3_lshiftrt_16_zexthi_clobber_flags */
    case 297:  /* *mulhisi3 */
    case 291:  /* *mulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 603:  /* *iorsi3_ashift_16_ashift_24 */
    case 586:  /* *iorsi3_w */
    case 583:  /* *iorsi3_e2f */
    case 580:  /* *iorsi3_two_hi */
    case 576:  /* *iorhi3_two_qi */
    case 560:  /* *addsi3_lshiftrt_16_zexthi */
    case 302:  /* *umulhisi3 */
    case 300:  /* *umulqihi3 */
    case 296:  /* *mulhisi3 */
    case 290:  /* *mulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 295:  /* *mulhisi3_const_cczn */
    case 289:  /* *mulqihi3_const_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 589:  /* *iorsi3_ashift_31_clobber_flags */
    case 575:  /* *iorhi3_lshiftrt_8_clobber_flags */
    case 573:  /* *iorhi3_ashift_8_clobber_flags */
    case 559:  /* *addsi3_upper_clobber_regs */
    case 294:  /* *mulhisi3_const */
    case 288:  /* *mulqihi3_const */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 450:  /* *extendhisi2_cczn */
    case 447:  /* *extendqisi2_h8sx_cczn */
    case 443:  /* *extendqihi2_cczn */
    case 440:  /* *zero_extendhisi2_cczn */
    case 437:  /* *zero_extendqisi2_h8sx_cczn */
    case 433:  /* *zero_extendqihi2_cczn */
    case 396:  /* one_cmplsi2__cczn */
    case 394:  /* one_cmplhi2__cczn */
    case 392:  /* one_cmplqi2__cczn */
    case 284:  /* *negsi2_flags_cczn */
    case 282:  /* *neghi2_flags_cczn */
    case 280:  /* *negqi2_flags_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 549:  /* *extzv_8_16_clobber_flags */
    case 547:  /* *extzv_8_8_clobber_flags */
    case 449:  /* *extendhisi2 */
    case 446:  /* *extendqisi2_h8sx */
    case 442:  /* *extendqihi2 */
    case 439:  /* *zero_extendhisi2 */
    case 436:  /* *zero_extendqisi2_h8sx */
    case 432:  /* *zero_extendqihi2 */
    case 398:  /* abssf2_clobber_flags */
    case 395:  /* one_cmplsi2_ */
    case 393:  /* one_cmplhi2_ */
    case 391:  /* one_cmplqi2_ */
    case 286:  /* *negsf2_clobber_flags */
    case 283:  /* *negsi2_flags */
    case 281:  /* *neghi2_flags */
    case 279:  /* *negqi2_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 552:  /* *extzv_8_23 */
    case 548:  /* *extzv_8_16 */
    case 546:  /* *extzv_8_8 */
    case 448:  /* *extendhisi2 */
    case 445:  /* *extendqisi2_h8sx */
    case 444:  /* *extendqisi2 */
    case 441:  /* *extendqihi2 */
    case 438:  /* *zero_extendhisi2 */
    case 435:  /* *zero_extendqisi2_h8sx */
    case 434:  /* *zero_extendqisi2 */
    case 431:  /* *zero_extendqihi2 */
    case 397:  /* abssf2 */
    case 390:  /* one_cmplsi2 */
    case 389:  /* one_cmplhi2 */
    case 388:  /* one_cmplqi2 */
    case 285:  /* *negsf2 */
    case 278:  /* *negsi2 */
    case 277:  /* *neghi2 */
    case 276:  /* *negqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 507:  /* *shiftsi_noscratch_cczn */
    case 506:  /* *shiftsi_noscratch_cczn */
    case 505:  /* *shiftsi_noscratch_cczn */
    case 492:  /* *shifthi_noscratch_setzn */
    case 491:  /* *shifthi_noscratch_setzn */
    case 490:  /* *shifthi_noscratch_setzn */
    case 477:  /* *shiftqi_noscratch_set_flags */
    case 476:  /* *shiftqi_noscratch_set_flags */
    case 475:  /* *shiftqi_noscratch_set_flags */
    case 387:  /* *andsi3_cczn */
    case 385:  /* *xorsi3_cczn */
    case 383:  /* *iorsi3_cczn */
    case 381:  /* *andhi3_cczn */
    case 379:  /* *xorhi3_cczn */
    case 377:  /* *iorhi3_cczn */
    case 375:  /* *andqi3_cczn */
    case 373:  /* *xorqi3_cczn */
    case 371:  /* *iorqi3_cczn */
    case 360:  /* *andqi3_1_cczn */
    case 358:  /* *xorqi3_1_cczn */
    case 356:  /* *iorqi3_1_cczn */
    case 354:  /* *xorqi3_1_cczn */
    case 352:  /* *iorqi3_1_cczn */
    case 350:  /* *xorqi3_1_cczn */
    case 348:  /* *iorqi3_1_cczn */
    case 275:  /* *subsi3_flags_cczn */
    case 273:  /* *subhi3_flags_cczn */
    case 269:  /* *subqi3_flags_cczn */
    case 266:  /* *addsi_flags_cczn */
    case 263:  /* *addhi3_h8sx_flags_cczn */
    case 260:  /* *addhi3_flags_cczn */
    case 257:  /* *addqi3_flags_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 519:  /* rotlsi3_1_clobber_flags */
    case 518:  /* rotlhi3_1_clobber_flags */
    case 517:  /* rotlqi3_1_clobber_flags */
    case 504:  /* *shiftsi_noscratch_clobber_flags */
    case 503:  /* *shiftsi_noscratch_clobber_flags */
    case 502:  /* *shiftsi_noscratch_clobber_flags */
    case 489:  /* *shifthi_noscratch_clobber_flags */
    case 488:  /* *shifthi_noscratch_clobber_flags */
    case 487:  /* *shifthi_noscratch_clobber_flags */
    case 474:  /* *shiftqi_noscratch_clobber_flags */
    case 473:  /* *shiftqi_noscratch_clobber_flags */
    case 472:  /* *shiftqi_noscratch_clobber_flags */
    case 386:  /* *andsi3 */
    case 384:  /* *xorsi3 */
    case 382:  /* *iorsi3 */
    case 380:  /* *andhi3 */
    case 378:  /* *xorhi3 */
    case 376:  /* *iorhi3 */
    case 374:  /* *andqi3 */
    case 372:  /* *xorqi3 */
    case 370:  /* *iorqi3 */
    case 359:  /* *andqi3_1 */
    case 357:  /* *xorqi3_1 */
    case 355:  /* *iorqi3_1 */
    case 353:  /* *xorqi3_1 */
    case 351:  /* *iorqi3_1 */
    case 349:  /* *xorqi3_1 */
    case 347:  /* *iorqi3_1 */
    case 331:  /* *andqi3_2_clobber_flags */
    case 319:  /* divsi3_clobber_flags */
    case 318:  /* divhi3_clobber_flags */
    case 315:  /* udivsi3_clobber_flags */
    case 314:  /* udivhi3_clobber_flags */
    case 306:  /* mulsi3_clobber_flags */
    case 305:  /* mulhi3_clobber_flags */
    case 274:  /* *subsi3_flags */
    case 272:  /* *subhi3_flags */
    case 268:  /* *subqi3_flags */
    case 265:  /* *addsi_flags */
    case 262:  /* *addhi3_h8sx_flags */
    case 259:  /* *addhi3_flags */
    case 256:  /* *addqi3_flags */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 555:  /* *andsi3_lshiftrt_n_sb */
    case 236:  /* *store_z_hi_and */
    case 235:  /* *store_z_hi_and */
    case 234:  /* *store_z_hi_and */
    case 233:  /* *store_z_hi_and */
    case 232:  /* *store_z_hi_and */
    case 231:  /* *store_z_hi_and */
    case 230:  /* *store_z_hi_and */
    case 229:  /* *store_z_hi_and */
    case 200:  /* *store_shifted_c */
    case 199:  /* *store_shifted_c */
    case 198:  /* *store_shifted_c */
    case 197:  /* *store_shifted_c */
    case 196:  /* *store_shifted_c */
    case 195:  /* *store_shifted_c */
    case 194:  /* *store_shifted_c */
    case 193:  /* *store_shifted_c */
    case 192:  /* *store_shifted_c */
    case 191:  /* *store_shifted_c */
    case 190:  /* *store_shifted_c */
    case 189:  /* *store_shifted_c */
    case 188:  /* *store_shifted_c */
    case 187:  /* *store_shifted_c */
    case 186:  /* *store_shifted_c */
    case 185:  /* *store_shifted_c */
    case 184:  /* *store_shifted_c */
    case 183:  /* *store_shifted_c */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 228:  /* *store_z_hi_neg */
    case 227:  /* *store_z_hi_neg */
    case 226:  /* *store_z_hi_neg */
    case 225:  /* *store_z_hi_neg */
    case 224:  /* *store_z_hi_neg */
    case 223:  /* *store_z_hi_neg */
    case 222:  /* *store_z_hi_neg */
    case 221:  /* *store_z_hi_neg */
    case 220:  /* *store_z_hi_sb */
    case 219:  /* *store_z_hi_sb */
    case 218:  /* *store_z_hi_sb */
    case 217:  /* *store_z_hi_sb */
    case 216:  /* *store_z_hi_sb */
    case 215:  /* *store_z_hi_sb */
    case 214:  /* *store_z_hi_sb */
    case 213:  /* *store_z_hi_sb */
    case 182:  /* *store_neg_c */
    case 181:  /* *store_neg_c */
    case 180:  /* *store_neg_c */
    case 179:  /* *store_neg_c */
    case 178:  /* *store_neg_c */
    case 177:  /* *store_neg_c */
    case 176:  /* *store_neg_c */
    case 175:  /* *store_neg_c */
    case 174:  /* *store_neg_c */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 516:  /* rotlsi3_1 */
    case 515:  /* rotlhi3_1 */
    case 514:  /* rotlqi3_1 */
    case 501:  /* *shiftsi_noscratch */
    case 500:  /* *shiftsi_noscratch */
    case 499:  /* *shiftsi_noscratch */
    case 486:  /* *shifthi_noscratch */
    case 485:  /* *shifthi_noscratch */
    case 484:  /* *shifthi_noscratch */
    case 471:  /* *shiftqi_noscratch */
    case 470:  /* *shiftqi_noscratch */
    case 469:  /* *shiftqi_noscratch */
    case 369:  /* *logicalsi3 */
    case 368:  /* *logicalsi3 */
    case 367:  /* *logicalsi3 */
    case 366:  /* *logicalhi3 */
    case 365:  /* *logicalhi3 */
    case 364:  /* *logicalhi3 */
    case 363:  /* *logicalqi3 */
    case 362:  /* *logicalqi3 */
    case 361:  /* *logicalqi3 */
    case 346:  /* xorqi3_1 */
    case 345:  /* iorqi3_1 */
    case 344:  /* bxorhi_msx */
    case 343:  /* biorhi_msx */
    case 342:  /* bxorqi_msx */
    case 341:  /* biorqi_msx */
    case 332:  /* andqi3_1 */
    case 330:  /* *andqi3_2 */
    case 329:  /* bclrhi_msx */
    case 328:  /* bclrqi_msx */
    case 317:  /* divsi3 */
    case 316:  /* divhi3 */
    case 313:  /* udivsi3 */
    case 312:  /* udivhi3 */
    case 304:  /* mulsi3 */
    case 303:  /* mulhi3 */
    case 271:  /* *subsi3 */
    case 270:  /* *subhi3 */
    case 267:  /* *subqi3 */
    case 264:  /* *addsi */
    case 261:  /* *addhi3_h8sx */
    case 258:  /* *addhi */
    case 255:  /* *addqi3 */
    case 212:  /* *store_z_hi */
    case 211:  /* *store_z_hi */
    case 210:  /* *store_z_hi */
    case 209:  /* *store_z_hi */
    case 208:  /* *store_z_hi */
    case 207:  /* *store_z_hi */
    case 206:  /* *store_z_hi */
    case 205:  /* *store_z_hi */
    case 202:  /* *store_z_i_qi */
    case 201:  /* *store_z_qi */
    case 173:  /* *store_c */
    case 172:  /* *store_c */
    case 171:  /* *store_c */
    case 170:  /* *store_c */
    case 169:  /* *store_c */
    case 168:  /* *store_c */
    case 167:  /* *store_c */
    case 166:  /* *store_c */
    case 165:  /* *store_c */
    case 164:  /* *store_c */
    case 163:  /* *store_c */
    case 162:  /* *store_c */
    case 161:  /* *store_c */
    case 160:  /* *store_c */
    case 159:  /* *store_c */
    case 158:  /* *store_c */
    case 157:  /* *store_c */
    case 156:  /* *store_c */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 252:  /* *store_z_si_and */
    case 251:  /* *store_z_si_and */
    case 250:  /* *store_z_hi_and */
    case 249:  /* *store_z_hi_and */
    case 155:  /* *store_shifted_csi */
    case 154:  /* *store_shifted_csi */
    case 153:  /* *store_shifted_chi */
    case 152:  /* *store_shifted_chi */
    case 151:  /* *store_shifted_cqi */
    case 150:  /* *store_shifted_cqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 248:  /* *store_z_si_neg */
    case 247:  /* *store_z_si_neg */
    case 246:  /* *store_z_hi_neg */
    case 245:  /* *store_z_hi_neg */
    case 244:  /* *store_z_si_sb */
    case 243:  /* *store_z_si_sb */
    case 242:  /* *store_z_hi_sb */
    case 241:  /* *store_z_hi_sb */
    case 240:  /* *store_z_si */
    case 239:  /* *store_z_si */
    case 238:  /* *store_z_hi */
    case 237:  /* *store_z_hi */
    case 204:  /* *store_z_i_qi */
    case 203:  /* *store_z_qi */
    case 149:  /* *store_neg_c_si */
    case 148:  /* *store_neg_c_hi */
    case 147:  /* *store_neg_c_qi */
    case 146:  /* *store_c_si */
    case 145:  /* *store_c_si */
    case 144:  /* *store_c_hi */
    case 143:  /* *store_c_hi */
    case 142:  /* *store_c_qi */
    case 141:  /* *store_c_qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 140:  /* cmpsi */
    case 139:  /* *cmphi */
    case 138:  /* *cmpqi */
    case 137:  /* *cmpsi_z */
    case 136:  /* *cmphi_z */
    case 135:  /* *cmpqi_z */
    case 134:  /* *cmpsi_c */
    case 133:  /* *cmphi_c */
    case 132:  /* *cmpqi_c */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 131:  /* *tstsi_upper */
    case 130:  /* *tsthi_upper_z */
    case 129:  /* *tsthi_upper */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 413:  /* jump */
    case 128:  /* *tstsi */
    case 127:  /* *tsthi */
    case 126:  /* *tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 125:  /* *testcompare.md:29 */
    case 124:  /* *testcompare.md:29 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 121:  /* *mova.md:747 */
    case 115:  /* *mova.md:692 */
    case 109:  /* *mova.md:637 */
    case 103:  /* *mova.md:582 */
    case 92:  /* *mova.md:483 */
    case 86:  /* *mova.md:428 */
    case 80:  /* *mova.md:373 */
    case 74:  /* *mova.md:318 */
    case 67:  /* *mova.md:255 */
    case 61:  /* *mova.md:200 */
    case 55:  /* *mova.md:145 */
    case 49:  /* *mova.md:90 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 120:  /* *mova.md:738 */
    case 114:  /* *mova.md:683 */
    case 108:  /* *mova.md:628 */
    case 102:  /* *mova.md:573 */
    case 91:  /* *mova.md:474 */
    case 85:  /* *mova.md:419 */
    case 79:  /* *mova.md:364 */
    case 73:  /* *mova.md:309 */
    case 66:  /* *mova.md:246 */
    case 60:  /* *mova.md:191 */
    case 54:  /* *mova.md:136 */
    case 48:  /* *mova.md:81 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 596:  /* *iorsi3_and_lshiftrt_n_sb */
    case 123:  /* *mova.md:766 */
    case 119:  /* *mova.md:729 */
    case 117:  /* *mova.md:711 */
    case 113:  /* *mova.md:674 */
    case 111:  /* *mova.md:656 */
    case 107:  /* *mova.md:619 */
    case 105:  /* *mova.md:601 */
    case 101:  /* *mova.md:564 */
    case 94:  /* *mova.md:502 */
    case 90:  /* *mova.md:465 */
    case 88:  /* *mova.md:447 */
    case 84:  /* *mova.md:410 */
    case 82:  /* *mova.md:392 */
    case 78:  /* *mova.md:355 */
    case 76:  /* *mova.md:337 */
    case 72:  /* *mova.md:300 */
    case 69:  /* *mova.md:274 */
    case 65:  /* *mova.md:237 */
    case 63:  /* *mova.md:219 */
    case 59:  /* *mova.md:182 */
    case 57:  /* *mova.md:164 */
    case 53:  /* *mova.md:127 */
    case 51:  /* *mova.md:109 */
    case 47:  /* *mova.md:72 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 609:  /* *combiner.md:1166 */
    case 607:  /* *combiner.md:1144 */
    case 606:  /* *ashiftsi_sextqi_7 */
    case 557:  /* *andsi3_lshiftrt_9_sb */
    case 553:  /* *twoshifts_l16_r1 */
    case 254:  /* *store_z */
    case 253:  /* *store_z */
    case 122:  /* *mova.md:757 */
    case 118:  /* *mova.md:721 */
    case 116:  /* *mova.md:702 */
    case 112:  /* *mova.md:666 */
    case 110:  /* *mova.md:647 */
    case 106:  /* *mova.md:611 */
    case 104:  /* *mova.md:592 */
    case 100:  /* *mova.md:556 */
    case 93:  /* *mova.md:493 */
    case 89:  /* *mova.md:457 */
    case 87:  /* *mova.md:438 */
    case 83:  /* *mova.md:402 */
    case 81:  /* *mova.md:383 */
    case 77:  /* *mova.md:347 */
    case 75:  /* *mova.md:328 */
    case 71:  /* *mova.md:292 */
    case 68:  /* *mova.md:265 */
    case 64:  /* *mova.md:229 */
    case 62:  /* *mova.md:210 */
    case 58:  /* *mova.md:174 */
    case 56:  /* *mova.md:155 */
    case 52:  /* *mova.md:119 */
    case 50:  /* *mova.md:100 */
    case 46:  /* *mova.md:64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 588:  /* *iorsi3_ashift_31 */
    case 574:  /* *iorhi3_lshiftrt_8 */
    case 572:  /* *iorhi3_ashift_8 */
    case 558:  /* *addsi3_upper */
    case 425:  /* sibcall_value_insn_si */
    case 424:  /* sibcall_value_insn_hi */
    case 421:  /* call_value_insn_si */
    case 420:  /* call_value_insn_hi */
    case 301:  /* *umulhisi3_const */
    case 299:  /* *umulqihi3_const */
    case 293:  /* *mulhisi3_const */
    case 287:  /* *mulqihi3_const */
    case 99:  /* *mova.md:548 */
    case 98:  /* *mova.md:539 */
    case 97:  /* *mova.md:530 */
    case 96:  /* *mova.md:521 */
    case 95:  /* *mova.md:512 */
    case 70:  /* *mova.md:284 */
    case 45:  /* *mova.md:56 */
    case 44:  /* *mova.md:47 */
    case 43:  /* *mova.md:38 */
    case 42:  /* *mova.md:29 */
    case 41:  /* *mova.md:20 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 40:  /* *push1_hi_cczn */
    case 38:  /* *push1_qi_cczn */
    case 36:  /* *push1_hi_cczn */
    case 34:  /* *push1_qi_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 39:  /* *push1_hi */
    case 37:  /* *push1_qi */
    case 35:  /* *push1_hi */
    case 33:  /* *push1_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 417:  /* *indirect_jump_si */
    case 416:  /* *indirect_jump_hi */
    case 32:  /* *push1_hi */
    case 31:  /* *push1_qi */
    case 30:  /* *push1_hi */
    case 29:  /* *push1_qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 18:  /* *movstricthi_cczn */
    case 9:  /* *movstrictqi_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 543:  /* *insv_si_8_8_clobber_flags */
    case 17:  /* *movstricthi */
    case 8:  /* *movstrictqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 542:  /* *insv_si_8_8 */
    case 423:  /* sibcall_insn_si */
    case 422:  /* sibcall_insn_hi */
    case 419:  /* call_insn_si */
    case 418:  /* call_insn_hi */
    case 16:  /* movstricthi */
    case 7:  /* movstrictqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 24:  /* *movsi_h8sx_ccnz */
    case 21:  /* *movsi_cczn */
    case 15:  /* *movhi_h8sx_cczn */
    case 12:  /* *movhi_cczn */
    case 6:  /* *movqi_h8sx_cczn */
    case 3:  /* *movqi_cczn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 28:  /* *movsf_clobber_flags */
    case 26:  /* *movsf_h8sx_clobber_flags */
    case 23:  /* *movsi_h8sx_clobber_flags */
    case 20:  /* *movsi_clobber_flags */
    case 14:  /* *movhi_h8sx */
    case 11:  /* *movhi */
    case 5:  /* *movqi_h8sx */
    case 2:  /* *movqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 27:  /* *movsf */
    case 25:  /* *movsf_h8sx */
    case 22:  /* *movsi_h8sx */
    case 19:  /* *movsi */
    case 13:  /* *movhi_h8sx */
    case 10:  /* *movhi */
    case 4:  /* *movqi_h8sx */
    case 1:  /* *movqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
