/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-13.2.1-20230728/gcc/config/loongarch/loongarch.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_w (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-13.2.1-20230728/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-13.2.1-20230728/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-13.2.1-20230728/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-13.2.1-20230728/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-13.2.1-20230728/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-13.2.1-20230728/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-13.2.1-20230728/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_b (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return is_const_call_no_local_symbol (op, mode);
}
static inline bool
satisfies_constraint_c (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return is_const_call_local_symbol (op, mode);
}
static inline bool
satisfies_constraint_k (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 119 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(loongarch_base_index_address_p (XEXP (op, 0), mode)));
}
static inline bool
satisfies_constraint_l (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 124 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(IMM16_OPERAND (ival)));
}
static inline bool
satisfies_constraint_m (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 131 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(loongarch_12bit_offset_address_p (XEXP (op, 0), mode)));
}
static inline bool
satisfies_constraint_u (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 139 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(LU32I_OPERAND (ival)));
}
static inline bool
satisfies_constraint_v (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 144 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(LU52I_OPERAND (ival)));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 154 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(op == CONST0_RTX (mode)));
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 161 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(IMM12_OPERAND (ival)));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 166 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 171 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(IMM12_OPERAND_UNSIGNED (ival)));
}
static inline bool
satisfies_constraint_Yd (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (move_operand (op, mode)) && (
#line 178 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(CONSTANT_P (op)));
}
static inline bool
satisfies_constraint_Yx (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return low_bitmask_operand (op, mode);
}
static inline bool
satisfies_constraint_ZC (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 189 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(loongarch_14bit_shifted_offset_address_p (XEXP (op, 0), mode)));
}
static inline bool
satisfies_constraint_ZB (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 196 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(REG_P (XEXP (op, 0))));
}
static inline bool
satisfies_constraint_ZD (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return 
#line 202 "../../gcc-13.2.1-20230728/gcc/config/loongarch/constraints.md"
(loongarch_12bit_offset_address_p (op, mode));
}
#endif /* tm-constrs.h */
