/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 58:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x38ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 55:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 57:  /* movqi_internal */
    case 56:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 131:  /* *signed_ge_zero */
    case 130:  /* *round_up_to_even */
    case 34:  /* one_cmplsi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2974 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 129:  /* sync_compare_and_swapsi */
    case 79:  /* rotrsi3 */
    case 78:  /* rotlsi3 */
    case 77:  /* *shlrd_per_byte_plus_omit_AND */
    case 76:  /* *shlrd_per_byte_ior_omit_AND */
    case 75:  /* *shlrd_per_byte_plus */
    case 74:  /* *shlrd_per_byte_ior */
    case 73:  /* *shlrd_const_plus */
    case 72:  /* *shlrd_const_ior */
    case 71:  /* *shlrd_reg_plus */
    case 70:  /* *shlrd_reg_ior */
    case 68:  /* *shift_per_byte_omit_AND_0 */
    case 67:  /* *shift_per_byte */
    case 39:  /* *andsi3_const_negative_pow2 */
    case 37:  /* *andsi3_bitcmpl */
      return 6;

    case 119:  /* *unspec_nop */
    case 116:  /* *frame_blockage */
    case 115:  /* blockage */
    case 91:  /* loop_end */
    case 90:  /* zero_cost_loop_end */
      return 0;

    case 118:  /* set_frame_ptr */
    case 112:  /* nop */
    case 111:  /* return */
      extract_constrain_insn_cached (insn);
      if (
#line 2974 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 117:  /* trap */
      extract_constrain_insn_cached (insn);
      if (
#line 2664 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(!TARGET_DEBUG && TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 88:  /* *masktrue_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 2048 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 87:  /* *masktrue_const_negative_pow2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2007 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[2]) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 86:  /* *masktrue_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 1967 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
((TARGET_DENSITY && INTVAL (operands[1]) == 0x7FFFFFFF)
				   && INTVAL (operands[2]) == 0))
        {
	  return 4;
        }
      else
        {
	  if (
#line 1970 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
						 && (INTVAL (operands[1]) == 0x7FFFFFFF
						     || INTVAL (operands[2]) == 0)))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 85:  /* *masktrue_const_bitcmpl */
      extract_constrain_insn_cached (insn);
      if (
#line 1878 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && IN_RANGE (INTVAL (operands[1]), -32, 95)))
        {
	  return 5;
        }
      else
        {
	  if (
#line 1881 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(xtensa_simm12b (INTVAL (operands[1]))))
	    {
	      return 6;
	    }
	  else
	    {
	      return 10 /* 0xa */;
	    }
        }

    case 80:  /* *btrue */
      extract_constrain_insn_cached (insn);
      if (
#line 1753 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && CONST_INT_P (operands[1])
				   && INTVAL (operands[1]) == 0
				   && (GET_CODE (operands[3]) == EQ
				       || GET_CODE (operands[3]) == NE)))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 69:  /* *shift_per_byte_omit_AND_1 */
    case 31:  /* bswaphi2 */
      return 9;

    case 66:  /* lshrsi3 */
    case 65:  /* ashrsi3 */
    case 64:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 43:  /* *splice_bits */
      extract_constrain_insn_cached (insn);
      if (
#line 851 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (INTVAL (operands[3]) == 0x7FFFFFFF
				       || INTVAL (operands[4]) == 0x7FFFFFFF)))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 12 /* 0xc */;
        }

    case 40:  /* *andsi3_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 761 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && ctz_hwi (INTVAL (operands[2])) == 1))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 38:  /* *andsi3_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 708 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && INTVAL (operands[2]) == 0x7FFFFFFF))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 32:  /* bswapsi2_internal */
      return 15 /* 0xf */;

    case 114:  /* eh_set_a0_call0 */
    case 113:  /* eh_set_a0_windowed */
    case 63:  /* movdf_internal */
    case 54:  /* movdi_internal */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 3;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 58:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x38ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 55:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 57:  /* movqi_internal */
    case 56:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 131:  /* *signed_ge_zero */
    case 130:  /* *round_up_to_even */
    case 34:  /* one_cmplsi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2974 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 129:  /* sync_compare_and_swapsi */
    case 79:  /* rotrsi3 */
    case 78:  /* rotlsi3 */
    case 77:  /* *shlrd_per_byte_plus_omit_AND */
    case 76:  /* *shlrd_per_byte_ior_omit_AND */
    case 75:  /* *shlrd_per_byte_plus */
    case 74:  /* *shlrd_per_byte_ior */
    case 73:  /* *shlrd_const_plus */
    case 72:  /* *shlrd_const_ior */
    case 71:  /* *shlrd_reg_plus */
    case 70:  /* *shlrd_reg_ior */
    case 68:  /* *shift_per_byte_omit_AND_0 */
    case 67:  /* *shift_per_byte */
    case 39:  /* *andsi3_const_negative_pow2 */
    case 37:  /* *andsi3_bitcmpl */
      return 6;

    case 119:  /* *unspec_nop */
    case 116:  /* *frame_blockage */
    case 115:  /* blockage */
    case 91:  /* loop_end */
    case 90:  /* zero_cost_loop_end */
      return 0;

    case 118:  /* set_frame_ptr */
    case 112:  /* nop */
    case 111:  /* return */
      extract_constrain_insn_cached (insn);
      if (
#line 2974 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 117:  /* trap */
      extract_constrain_insn_cached (insn);
      if (
#line 2664 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(!TARGET_DEBUG && TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 88:  /* *masktrue_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 2048 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 87:  /* *masktrue_const_negative_pow2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2007 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[2]) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 86:  /* *masktrue_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 1967 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
((TARGET_DENSITY && INTVAL (operands[1]) == 0x7FFFFFFF)
				   && INTVAL (operands[2]) == 0))
        {
	  return 4;
        }
      else
        {
	  if (
#line 1970 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
						 && (INTVAL (operands[1]) == 0x7FFFFFFF
						     || INTVAL (operands[2]) == 0)))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 85:  /* *masktrue_const_bitcmpl */
      extract_constrain_insn_cached (insn);
      if (
#line 1878 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && IN_RANGE (INTVAL (operands[1]), -32, 95)))
        {
	  return 5;
        }
      else
        {
	  if (
#line 1881 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(xtensa_simm12b (INTVAL (operands[1]))))
	    {
	      return 6;
	    }
	  else
	    {
	      return 10 /* 0xa */;
	    }
        }

    case 80:  /* *btrue */
      extract_constrain_insn_cached (insn);
      if (
#line 1753 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && CONST_INT_P (operands[1])
				   && INTVAL (operands[1]) == 0
				   && (GET_CODE (operands[3]) == EQ
				       || GET_CODE (operands[3]) == NE)))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 69:  /* *shift_per_byte_omit_AND_1 */
    case 31:  /* bswaphi2 */
      return 9;

    case 66:  /* lshrsi3 */
    case 65:  /* ashrsi3 */
    case 64:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 43:  /* *splice_bits */
      extract_constrain_insn_cached (insn);
      if (
#line 851 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (INTVAL (operands[3]) == 0x7FFFFFFF
				       || INTVAL (operands[4]) == 0x7FFFFFFF)))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 12 /* 0xc */;
        }

    case 40:  /* *andsi3_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 761 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && ctz_hwi (INTVAL (operands[2])) == 1))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 38:  /* *andsi3_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 708 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && INTVAL (operands[2]) == 0x7FFFFFFF))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 32:  /* bswapsi2_internal */
      return 15 /* 0xf */;

    case 114:  /* eh_set_a0_call0 */
    case 113:  /* eh_set_a0_windowed */
    case 63:  /* movdf_internal */
    case 54:  /* movdi_internal */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 3;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_mode
get_attr_mode (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 96:  /* seq_sf */
    case 97:  /* slt_sf */
    case 98:  /* sle_sf */
    case 99:  /* suneq_sf */
    case 100:  /* sunlt_sf */
    case 101:  /* sunle_sf */
    case 102:  /* sunordered_sf */
      return MODE_BL;

    case 3:  /* addsf3 */
    case 6:  /* subsf3 */
    case 14:  /* mulsf3 */
    case 15:  /* fmasf4 */
    case 16:  /* fnmasf4 */
    case 22:  /* abssf2 */
    case 35:  /* negsf2 */
    case 50:  /* fix_truncsfsi2 */
    case 51:  /* fixuns_truncsfsi2 */
    case 52:  /* floatsisf2 */
    case 53:  /* floatunssisf2 */
    case 58:  /* movsf_internal */
    case 59:  /* *lsiu */
    case 60:  /* *ssiu */
    case 61:  /* *lsip */
    case 62:  /* *ssip */
    case 94:  /* movsfcc_internal0 */
    case 95:  /* movsfcc_internal1 */
      return MODE_SF;

    case 31:  /* bswaphi2 */
    case 56:  /* movhi_internal */
      return MODE_HI;

    case 57:  /* movqi_internal */
      return MODE_QI;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 80:  /* *btrue */
    case 81:  /* *ubtrue */
    case 82:  /* *bittrue */
    case 83:  /* *masktrue */
    case 84:  /* *masktrue_bitcmpl */
    case 85:  /* *masktrue_const_bitcmpl */
    case 86:  /* *masktrue_const_pow2_minus_one */
    case 87:  /* *masktrue_const_negative_pow2 */
    case 88:  /* *masktrue_const_shifted_mask */
    case 89:  /* zero_cost_loop_start */
    case 90:  /* zero_cost_loop_end */
    case 91:  /* loop_end */
    case 103:  /* jump */
    case 104:  /* indirect_jump_internal */
    case 105:  /* tablejump_internal */
    case 106:  /* call_internal */
    case 107:  /* call_value_internal */
    case 108:  /* sibcall_internal */
    case 109:  /* sibcall_value_internal */
    case 111:  /* return */
    case 112:  /* nop */
    case 115:  /* blockage */
    case 116:  /* *frame_blockage */
    case 117:  /* trap */
    case 119:  /* *unspec_nop */
    case 124:  /* tls_call */
    case 125:  /* *booltrue */
    case 126:  /* *boolfalse */
    case 127:  /* *memory_barrier */
      return MODE_NONE;

    case 54:  /* movdi_internal */
    case 63:  /* movdf_internal */
    case 113:  /* eh_set_a0_windowed */
    case 114:  /* eh_set_a0_call0 */
      return MODE_UNKNOWN;

    default:
      return MODE_SI;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 58:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_FARITH;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_FLOAD;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_FSTORE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x180ULL))
        {
	  return TYPE_FARITH;
        }
      else if (((1ULL << which_alternative) & 0x600ULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 57:  /* movqi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 56:  /* movhi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 55:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_LOAD;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return TYPE_STORE;
        }
      else if (((1ULL << which_alternative) & 0x7c0ULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 13)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 14)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 10:  /* mulhisi3 */
    case 11:  /* umulhisi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_MUL16;
        }
      else
        {
	  return TYPE_MAC16;
        }

    case 44:  /* zero_extendhisi2 */
    case 45:  /* zero_extendqisi2 */
    case 46:  /* extendhisi2_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ARITH;
        }
      else
        {
	  return TYPE_LOAD;
        }

    case 117:  /* trap */
      return TYPE_TRAP;

    case 110:  /* entry */
      return TYPE_ENTRY;

    case 121:  /* set_thread_pointersi */
      return TYPE_WSR;

    case 120:  /* get_thread_pointersi */
      return TYPE_RSR;

    case 12:  /* muladdhisi */
    case 13:  /* mulsubhisi */
      return TYPE_MAC16;

    case 17:  /* divsi3 */
    case 18:  /* udivsi3 */
    case 19:  /* modsi3 */
    case 20:  /* umodsi3 */
      return TYPE_DIV32;

    case 7:  /* mulsi3_highpart */
    case 8:  /* umulsi3_highpart */
    case 9:  /* mulsi3 */
      return TYPE_MUL32;

    case 60:  /* *ssiu */
    case 62:  /* *ssip */
      return TYPE_FSTORE;

    case 59:  /* *lsiu */
    case 61:  /* *lsip */
      return TYPE_FLOAD;

    case 50:  /* fix_truncsfsi2 */
    case 51:  /* fixuns_truncsfsi2 */
    case 52:  /* floatsisf2 */
    case 53:  /* floatunssisf2 */
      return TYPE_FCONV;

    case 3:  /* addsf3 */
    case 6:  /* subsf3 */
    case 14:  /* mulsf3 */
    case 15:  /* fmasf4 */
    case 16:  /* fnmasf4 */
      return TYPE_FMADD;

    case 22:  /* abssf2 */
    case 35:  /* negsf2 */
    case 96:  /* seq_sf */
    case 97:  /* slt_sf */
    case 98:  /* sle_sf */
    case 99:  /* suneq_sf */
    case 100:  /* sunlt_sf */
    case 101:  /* sunle_sf */
    case 102:  /* sunordered_sf */
      return TYPE_FARITH;

    case 112:  /* nop */
    case 115:  /* blockage */
    case 116:  /* *frame_blockage */
    case 119:  /* *unspec_nop */
      return TYPE_NOP;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 78:  /* rotlsi3 */
    case 79:  /* rotrsi3 */
    case 129:  /* sync_compare_and_swapsi */
      return TYPE_MULTI;

    case 92:  /* movsicc_internal0 */
    case 93:  /* movsicc_internal1 */
    case 94:  /* movsfcc_internal0 */
    case 95:  /* movsfcc_internal1 */
    case 118:  /* set_frame_ptr */
      return TYPE_MOVE;

    case 128:  /* sync_lock_releasesi */
      return TYPE_STORE;

    case 122:  /* tls_func */
    case 123:  /* tls_arg */
      return TYPE_LOAD;

    case 106:  /* call_internal */
    case 107:  /* call_value_internal */
    case 108:  /* sibcall_internal */
    case 109:  /* sibcall_value_internal */
    case 124:  /* tls_call */
      return TYPE_CALL;

    case 80:  /* *btrue */
    case 81:  /* *ubtrue */
    case 82:  /* *bittrue */
    case 83:  /* *masktrue */
    case 84:  /* *masktrue_bitcmpl */
    case 85:  /* *masktrue_const_bitcmpl */
    case 86:  /* *masktrue_const_pow2_minus_one */
    case 87:  /* *masktrue_const_negative_pow2 */
    case 88:  /* *masktrue_const_shifted_mask */
    case 89:  /* zero_cost_loop_start */
    case 90:  /* zero_cost_loop_end */
    case 91:  /* loop_end */
    case 103:  /* jump */
    case 104:  /* indirect_jump_internal */
    case 105:  /* tablejump_internal */
    case 111:  /* return */
    case 125:  /* *booltrue */
    case 126:  /* *boolfalse */
      return TYPE_JUMP;

    case 54:  /* movdi_internal */
    case 63:  /* movdf_internal */
    case 113:  /* eh_set_a0_windowed */
    case 114:  /* eh_set_a0_call0 */
    case 127:  /* *memory_barrier */
      return TYPE_UNKNOWN;

    default:
      return TYPE_ARITH;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
