/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_1[] = {
  "add.n\t%0, %1, %2",
  "addi.n\t%0, %1, %d2",
  "add\t%0, %1, %2",
  "addi\t%0, %1, %d2",
  "addmi\t%0, %1, %x2",
};

static const char *
output_2 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 179 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  operands[3] = GEN_INT (1 << INTVAL (operands[3]));
  return "addx%3\t%0, %1, %2";
}
}

static const char *
output_5 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 216 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  operands[3] = GEN_INT (1 << INTVAL (operands[3]));
  return "subx%3\t%0, %1, %2";
}
}

static const char * const output_10[] = {
  "mul16s\t%0, %1, %2",
  "mul.aa.ll\t%1, %2",
};

static const char * const output_11[] = {
  "mul16u\t%0, %1, %2",
  "umul.aa.ll\t%1, %2",
};

static const char *
output_28 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 477 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "clamps\t%%0, %%1, %d", floor_log2 (-INTVAL (operands[2])));
  return result;
}
}

static const char *
output_32 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 572 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  rtx_insn *prev_insn = prev_nonnote_nondebug_insn (insn);
  const char *init = "ssai\t8\n\t";
  static char result[128];
  if (prev_insn && NONJUMP_INSN_P (prev_insn))
    {
      rtx x = PATTERN (prev_insn);
      if (GET_CODE (x) == PARALLEL && XVECLEN (x, 0) == 2
	  && GET_CODE (XVECEXP (x, 0, 0)) == SET
	  && GET_CODE (XVECEXP (x, 0, 1)) == CLOBBER)
	{
	  x = XEXP (XVECEXP (x, 0, 0), 1);
	  if (GET_CODE (x) == BSWAP && GET_MODE (x) == SImode)
	    init = "";
	}
    }
  sprintf (result,
	   (which_alternative == 0)
	   ? "%s" "srli\t%%2, %%1, 16\n\tsrc\t%%2, %%2, %%1\n\tsrc\t%%2, %%2, %%2\n\tsrc\t%%0, %%1, %%2"
	   : "%s" "srli\t%%0, %%1, 16\n\tsrc\t%%0, %%0, %%1\n\tsrc\t%%0, %%0, %%0\n\tsrc\t%%0, %%1, %%0",
	   init);
  return result;
}
}

static const char * const output_36[] = {
  "extui\t%0, %1, 0, %K2",
  "and\t%0, %1, %2",
};

static const char * const output_44[] = {
  "extui\t%0, %1, 0, 16",
  "%v1l16ui\t%0, %1",
};

static const char * const output_45[] = {
  "extui\t%0, %1, 0, 8",
  "%v1l8ui\t%0, %1",
};

static const char * const output_46[] = {
  "sext\t%0, %1, 15",
  "%v1l16si\t%0, %1",
};

static const char *
output_48 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 958 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  int fldsz = INTVAL (operands[2]);
  operands[2] = GEN_INT (fldsz - 1);
  return "sext\t%0, %1, %2";
}
}

static const char *
output_49 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 987 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  int shift;
  if (BITS_BIG_ENDIAN)
    shift = (32 - (INTVAL (operands[2]) + INTVAL (operands[3]))) & 0x1f;
  else
    shift = INTVAL (operands[3]) & 0x1f;
  operands[3] = GEN_INT (shift);
  return "extui\t%0, %1, %3, %2";
}
}

static const char * const output_55[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "movsp\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_56[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "%v1l16ui\t%0, %1",
  "%v0s16i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_57[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "%v1l8ui\t%0, %1",
  "%v0s8i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_58[] = {
  "mov.s\t%0, %1",
  "%v1lsi\t%0, %1",
  "%v0ssi\t%1, %0",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "wfr\t%0, %1",
  "rfr\t%0, %1",
  "movi\t%0, %y1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
};

static const char *
output_59 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1312 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsiu\t%0, %1, %2";
}
}

static const char *
output_60 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1328 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssiu\t%2, %0, %1";
}
}

static const char *
output_61 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1344 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsip\t%0, %1, %2";
}
}

static const char *
output_62 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1360 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssip\t%1, %0, %2";
}
}

static const char * const output_64[] = {
  "slli\t%0, %1, %R2",
  "ssl\t%2\n\tsll\t%0, %1",
};

static const char * const output_65[] = {
  "srai\t%0, %1, %R2",
  "ssr\t%2\n\tsra\t%0, %1",
};

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1504 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (which_alternative == 0)
    {
      if ((INTVAL (operands[2]) & 0x1f) < 16)
	return "srli\t%0, %1, %R2";
      else
	return "extui\t%0, %1, %R2, %L2";
    }
  return "ssr\t%2\n\tsrl\t%0, %1";
}
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1525 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsll\t%0, %1";
    case ASHIFTRT:	return "ssa8l\t%2\n\tsra\t%0, %1";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrl\t%0, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_70 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1594 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssl\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssr\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_71 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1594 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssl\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssr\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_72 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1619 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[5], operands[6]))
    {
    case ASHIFT:	return "ssai\t%L3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssai\t%R3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1619 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[5], operands[6]))
    {
    case ASHIFT:	return "ssai\t%L3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssai\t%R3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_74 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1643 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_75 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1643 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char * const output_78[] = {
  "ssai\t%L2\n\tsrc\t%0, %1, %1",
  "ssl\t%2\n\tsrc\t%0, %1, %1",
};

static const char * const output_79[] = {
  "ssai\t%R2\n\tsrc\t%0, %1, %1",
  "ssr\t%2\n\tsrc\t%0, %1, %1",
};

static const char *
output_80 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1747 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_81 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1769 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_82 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1788 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  char op;
  switch (GET_CODE (operands[3]))
    {
    case EQ:	op = 'c'; break;
    case NE:	op = 's'; break;
    default:	gcc_unreachable ();
    }
  if (which_alternative == 0)
    {
      operands[1] = GEN_INT (INTVAL (operands[1]) & 0x1f);
      sprintf (result, "bb%ci\t%%0, %%d1, %%2", op);
    }
  else
    sprintf (result, "bb%c\t%%0, %%1, %%2", op);
  return result;
}
}

static const char *
output_83 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1819 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "bnone\t%0, %1, %2";
    case NE:	return "bany\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_84 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1840 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "ball\t%0, %1, %2";
    case NE:	return "bnall\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_91 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2105 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  xtensa_emit_loop_end (insn, operands);
  return "";
}
}

static const char *
output_92 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2231 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, false, operands);
}
}

static const char *
output_93 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2246 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, true, operands);
}
}

static const char *
output_94 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2261 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, false, operands);
}
}

static const char *
output_95 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2277 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, true, operands);
}
}

static const char *
output_106 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2381 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (0, operands);
}
}

static const char *
output_107 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2403 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (1, operands);
}
}

static const char *
output_108 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2423 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (0, operands);
}
}

static const char *
output_109 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2445 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (1, operands);
}
}

static const char *
output_111 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2487 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return TARGET_WINDOWED_ABI ?
      (TARGET_DENSITY ? "retw.n" : "retw") :
      (TARGET_DENSITY ? "ret.n" : "ret");
}
}

static const char *
output_112 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2555 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  return (TARGET_DENSITY ? "nop.n" : "nop");
}
}

static const char *
output_117 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2655 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_DEBUG)
    return "break\t1, 15";
  else
    return (TARGET_DENSITY ? "ill.n" : "ill");
}
}

static const char *
output_118 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2686 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (frame_pointer_needed)
    return (TARGET_DENSITY ? "mov.n\ta7, sp" : "mov\ta7, sp");
  return "";
}
}

static const char *
output_124 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2774 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_WINDOWED_ABI)
    return "callx8.tls %1, %2@TLSCALL";
  else
    return "callx0.tls %1, %2@TLSCALL";
}
}

static const char *
output_125 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2795 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bf\t%0, %1";
  else
    return "bt\t%0, %1";
}
}

static const char *
output_126 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2813 "../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bt\t%0, %1";
  else
    return "bf\t%0, %1";
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=D,D,a,a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%d,d,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "d,O,r,J,N",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsubx_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=C,A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a",
    E_HImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a,X",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mask_operand,
    "P,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    lsbitnum_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    extui_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,W,a,a,U",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,i,T,U,r",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,D,D,R,R,a,q,a,a,W,a,a,U,*a,*A",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,D,d,R,D,d,r,r,I,Y,i,T,U,r,*A,*r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,a,U,*a,*A",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,Y,U,r,*A,*r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,U,*a,*A",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,U,r,*A,*r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=f,f,U,D,D,R,a,f,a,a,W,a,a,U",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "f,U,f,d,R,d,r,r,f,Y,iF,T,U,r",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,a,W,a,a,U",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,Y,iF,T,U,r",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operand,
    "K,?r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operand,
    "L,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=a,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b,b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    mem_operand,
    "=U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "+U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_cstoresi_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    add_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:158 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[1],
    3,
    3,
    0,
    5,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:173 */
  {
    "*addx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_2 },
#else
    { 0, 0, output_2 },
#endif
    { 0 },
    &operand_data[4],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:187 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[8],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:200 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:210 */
  {
    "*subx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_5 },
#else
    { 0, 0, output_5 },
#endif
    { 0 },
    &operand_data[4],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:224 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[11],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:273 */
  {
    "mulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulsh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3_highpart },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:273 */
  {
    "umulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muluh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsi3_highpart },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:286 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mull\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:296 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[17],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:296 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[17],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:310 */
  {
    "muladdhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mula.aa.ll\t%1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_muladdhisi },
    &operand_data[20],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:323 */
  {
    "mulsubhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muls.aa.ll\t%2, %3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsubhisi },
    &operand_data[24],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:336 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[8],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:346 */
  {
    "fmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "madd.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmasf4 },
    &operand_data[28],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:358 */
  {
    "fnmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "msub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmasf4 },
    &operand_data[28],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:372 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quos\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:382 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quou\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:395 */
  {
    "modsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rems\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_modsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:405 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "remu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:418 */
  {
    "abssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:427 */
  {
    "abssf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssf2 },
    &operand_data[11],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:439 */
  {
    "sminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "min\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sminsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:439 */
  {
    "uminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "minu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_uminsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:439 */
  {
    "smaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "max\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_smaxsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:439 */
  {
    "umaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "maxu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umaxsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:452 */
  {
    "*xtensa_clamps",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:470 */
  {
    "*xtensa_clamps",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_28 },
#else
    { 0, 0, output_28 },
#endif
    { 0 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:490 */
  {
    "clrsbsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsa\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clrsbsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:499 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsau\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:539 */
  {
    "bswaphi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "extui\t%2, %1, 8, 8\n\tslli\t%0, %1, 8\n\tor\t%0, %0, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswaphi2 },
    &operand_data[36],
    2,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:567 */
  {
    "bswapsi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_32 },
#else
    { 0, 0, output_32 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2_internal },
    &operand_data[39],
    2,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:615 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:624 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:645 */
  {
    "negsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsf2 },
    &operand_data[11],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:657 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_36 },
#else
    { 0, output_36, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[42],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:669 */
  {
    "*andsi3_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:689 */
  {
    "*andsi3_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[32],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:713 */
  {
    "*andsi3_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[32],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:733 */
  {
    "*andsi3_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[45],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:766 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:800 */
  {
    "xorsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3_internal },
    &operand_data[14],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:810 */
  {
    "*splice_bits",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[48],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:860 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[53],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:871 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[55],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:897 */
  {
    "extendhisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2_internal },
    &operand_data[57],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:920 */
  {
    "extendqisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sext\t%0, %1, 7",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2_internal },
    &operand_data[59],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:952 */
  {
    "extvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_48 },
#else
    { 0, 0, output_48 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi_internal },
    &operand_data[61],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:981 */
  {
    "extzvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_49 },
#else
    { 0, 0, output_49 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi_internal },
    &operand_data[65],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1003 */
  {
    "fix_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "trunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fix_truncsfsi2 },
    &operand_data[69],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1012 */
  {
    "fixuns_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "utrunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fixuns_truncsfsi2 },
    &operand_data[69],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1021 */
  {
    "floatsisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "float.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2 },
    &operand_data[71],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1030 */
  {
    "floatunssisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ufloat.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatunssisf2 },
    &operand_data[71],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1073 */
  {
    "movdi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi_internal },
    &operand_data[73],
    2,
    2,
    0,
    5,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1116 */
  {
    "movsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_55 },
#else
    { 0, output_55, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_internal },
    &operand_data[75],
    2,
    2,
    0,
    16,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1178 */
  {
    "movhi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_56 },
#else
    { 0, output_56, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi_internal },
    &operand_data[77],
    2,
    2,
    0,
    9,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1207 */
  {
    "movqi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_57 },
#else
    { 0, output_57, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_internal },
    &operand_data[79],
    2,
    2,
    0,
    8,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1279 */
  {
    "movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_58 },
#else
    { 0, output_58, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf_internal },
    &operand_data[81],
    2,
    2,
    0,
    14,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1305 */
  {
    "*lsiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_59 },
#else
    { 0, 0, output_59 },
#endif
    { 0 },
    &operand_data[83],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1321 */
  {
    "*ssiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_60 },
#else
    { 0, 0, output_60 },
#endif
    { 0 },
    &operand_data[84],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1337 */
  {
    "*lsip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_61 },
#else
    { 0, 0, output_61 },
#endif
    { 0 },
    &operand_data[83],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1353 */
  {
    "*ssip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_62 },
#else
    { 0, 0, output_62 },
#endif
    { 0 },
    &operand_data[87],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1405 */
  {
    "movdf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf_internal },
    &operand_data[90],
    2,
    2,
    0,
    6,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1466 */
  {
    "ashlsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_64 },
#else
    { 0, output_64, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_internal },
    &operand_data[92],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1487 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_65 },
#else
    { 0, output_65, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1499 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1518 */
  {
    "*shift_per_byte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    { 0 },
    &operand_data[95],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1538 */
  {
    "*shift_per_byte_omit_AND_0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[99],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1559 */
  {
    "*shift_per_byte_omit_AND_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[99],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1584 */
  {
    "*shlrd_reg_ior",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_70 },
#else
    { 0, 0, output_70 },
#endif
    { 0 },
    &operand_data[104],
    6,
    6,
    1,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1584 */
  {
    "*shlrd_reg_plus",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_71 },
#else
    { 0, 0, output_71 },
#endif
    { 0 },
    &operand_data[104],
    6,
    6,
    1,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1606 */
  {
    "*shlrd_const_ior",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_72 },
#else
    { 0, 0, output_72 },
#endif
    { 0 },
    &operand_data[110],
    7,
    7,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1606 */
  {
    "*shlrd_const_plus",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    { 0 },
    &operand_data[110],
    7,
    7,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1631 */
  {
    "*shlrd_per_byte_ior",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_74 },
#else
    { 0, 0, output_74 },
#endif
    { 0 },
    &operand_data[104],
    6,
    6,
    1,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1631 */
  {
    "*shlrd_per_byte_plus",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_75 },
#else
    { 0, 0, output_75 },
#endif
    { 0 },
    &operand_data[104],
    6,
    6,
    1,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1655 */
  {
    "*shlrd_per_byte_ior_omit_AND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    7,
    7,
    2,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1655 */
  {
    "*shlrd_per_byte_plus_omit_AND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    7,
    7,
    2,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1686 */
  {
    "rotlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_78 },
#else
    { 0, output_78, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotlsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1698 */
  {
    "rotrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_79 },
#else
    { 0, output_79, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotrsi3 },
    &operand_data[92],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1739 */
  {
    "*btrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_80 },
#else
    { 0, 0, output_80 },
#endif
    { 0 },
    &operand_data[124],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1761 */
  {
    "*ubtrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_81 },
#else
    { 0, 0, output_81 },
#endif
    { 0 },
    &operand_data[128],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1778 */
  {
    "*bittrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_82 },
#else
    { 0, 0, output_82 },
#endif
    { 0 },
    &operand_data[132],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1810 */
  {
    "*masktrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_83 },
#else
    { 0, 0, output_83 },
#endif
    { 0 },
    &operand_data[136],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1831 */
  {
    "*masktrue_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_84 },
#else
    { 0, 0, output_84 },
#endif
    { 0 },
    &operand_data[136],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1852 */
  {
    "*masktrue_const_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[140],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1936 */
  {
    "*masktrue_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[144],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1976 */
  {
    "*masktrue_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[144],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2011 */
  {
    "*masktrue_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[149],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2061 */
  {
    "zero_cost_loop_start",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "loop\t%0, %l1_LEND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_start },
    &operand_data[154],
    3,
    3,
    1,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2077 */
  {
    "zero_cost_loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_end },
    &operand_data[157],
    3,
    4,
    1,
    2,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2094 */
  {
    "loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_91 },
#else
    { 0, 0, output_91 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_loop_end },
    &operand_data[154],
    3,
    3,
    1,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2223 */
  {
    "movsicc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_92 },
#else
    { 0, 0, output_92 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal0 },
    &operand_data[161],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2238 */
  {
    "movsicc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_93 },
#else
    { 0, 0, output_93 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal1 },
    &operand_data[166],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2253 */
  {
    "movsfcc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_94 },
#else
    { 0, 0, output_94 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal0 },
    &operand_data[171],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2269 */
  {
    "movsfcc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_95 },
#else
    { 0, 0, output_95 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal1 },
    &operand_data[176],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "seq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "oeq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_seq_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "slt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "olt.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slt_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "sle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ole.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sle_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "suneq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ueq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_suneq_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "sunlt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ult.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunlt_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "sunle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ule.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunle_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2288 */
  {
    "sunordered_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "un.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunordered_sf },
    &operand_data[181],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2301 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "j\t%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[126],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2323 */
  {
    "indirect_jump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump_internal },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2350 */
  {
    "tablejump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal },
    &operand_data[137],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2377 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_106 },
#else
    { 0, 0, output_106 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[184],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2398 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_107 },
#else
    { 0, 0, output_107 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[186],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2419 */
  {
    "sibcall_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_108 },
#else
    { 0, 0, output_108 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_internal },
    &operand_data[189],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2440 */
  {
    "sibcall_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_109 },
#else
    { 0, 0, output_109 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value_internal },
    &operand_data[191],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2473 */
  {
    "entry",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "entry\tsp, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_entry },
    &operand_data[34],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2483 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_111 },
#else
    { 0, 0, output_111 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2552 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_112 },
#else
    { 0, 0, output_112 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2594 */
  {
    "eh_set_a0_windowed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_windowed },
    &operand_data[194],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2607 */
  {
    "eh_set_a0_call0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_call0 },
    &operand_data[194],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2623 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2643 */
  {
    "*frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[196],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2652 */
  {
    "trap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_117 },
#else
    { 0, 0, output_117 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_trap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2683 */
  {
    "set_frame_ptr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_118 },
#else
    { 0, 0, output_118 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_frame_ptr },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2708 */
  {
    "*unspec_nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2729 */
  {
    "get_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_get_thread_pointersi },
    &operand_data[4],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2738 */
  {
    "set_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_thread_pointersi },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2747 */
  {
    "tls_func",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSFUNC",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_func },
    &operand_data[198],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2757 */
  {
    "tls_arg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSARG",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_arg },
    &operand_data[198],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2767 */
  {
    "tls_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_124 },
#else
    { 0, 0, output_124 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_call },
    &operand_data[200],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2787 */
  {
    "*booltrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_125 },
#else
    { 0, 0, output_125 },
#endif
    { 0 },
    &operand_data[204],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2805 */
  {
    "*boolfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_126 },
#else
    { 0, 0, output_126 },
#endif
    { 0 },
    &operand_data[204],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2835 */
  {
    "*memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "memw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[196],
    1,
    1,
    1,
    0,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2846 */
  {
    "sync_lock_releasesi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "s32ri\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_releasesi },
    &operand_data[207],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2857 */
  {
    "sync_compare_and_swapsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wsr\t%2, SCOMPARE1\n\ts32c1i\t%3, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapsi },
    &operand_data[209],
    4,
    4,
    2,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2933 */
  {
    "*round_up_to_even",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2957 */
  {
    "*signed_ge_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:237 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[213],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:251 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[213],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:508 */
  {
    "ctzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ctzsi2 },
    &operand_data[214],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:522 */
  {
    "ffssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ffssi2 },
    &operand_data[214],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:549 */
  {
    "bswapsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2 },
    &operand_data[214],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:599 */
  {
    "bswapdi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapdi2 },
    &operand_data[216],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:776 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[218],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:885 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[221],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:908 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[223],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:932 */
  {
    "extvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi },
    &operand_data[225],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:967 */
  {
    "extzvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi },
    &operand_data[225],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1044 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[229],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1107 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[231],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1169 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[233],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1198 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[235],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1226 */
  {
    "reloadhi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadhi_literal },
    &operand_data[237],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1226 */
  {
    "reloadqi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadqi_literal },
    &operand_data[240],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1260 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[243],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1390 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[245],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1426 */
  {
    "cpymemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cpymemsi },
    &operand_data[247],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1440 */
  {
    "setmemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_setmemsi },
    &operand_data[251],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1457 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[255],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1715 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[258],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:1726 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[262],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2149 */
  {
    "doloop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_doloop_end },
    &operand_data[266],
    2,
    2,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2171 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[268],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2183 */
  {
    "cstoresf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresf4 },
    &operand_data[272],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2199 */
  {
    "movsicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc },
    &operand_data[276],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2211 */
  {
    "movsfcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc },
    &operand_data[280],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2310 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[284],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2332 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[285],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2363 */
  {
    "sym_PLT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_PLT },
    &operand_data[197],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2368 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[287],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2388 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[289],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2410 */
  {
    "sibcall",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall },
    &operand_data[287],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2430 */
  {
    "sibcall_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value },
    &operand_data[289],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2452 */
  {
    "untyped_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_untyped_call },
    &operand_data[291],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2506 */
  {
    "allocate_stack",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_allocate_stack },
    &operand_data[294],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2528 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2536 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2544 */
  {
    "sibcall_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2565 */
  {
    "nonlocal_goto",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nonlocal_goto },
    &operand_data[296],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2583 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[300],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2633 */
  {
    "frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_frame_blockage },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2719 */
  {
    "sym_TPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_TPOFF },
    &operand_data[197],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2724 */
  {
    "sym_DTPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_DTPOFF },
    &operand_data[197],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2826 */
  {
    "memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_memory_barrier },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2873 */
  {
    "sync_compare_and_swaphi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swaphi },
    &operand_data[301],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2873 */
  {
    "sync_compare_and_swapqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapqi },
    &operand_data[305],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2890 */
  {
    "sync_lock_test_and_sethi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_sethi },
    &operand_data[309],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2890 */
  {
    "sync_lock_test_and_setqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_setqi },
    &operand_data[312],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandhi },
    &operand_data[310],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2900 */
  {
    "sync_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandqi },
    &operand_data[313],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandhi },
    &operand_data[309],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2910 */
  {
    "sync_old_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandqi },
    &operand_data[312],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandhi },
    &operand_data[309],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-13.2.1-20230728/gcc/config/xtensa/xtensa.md:2922 */
  {
    "sync_new_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandqi },
    &operand_data[312],
    3,
    3,
    3,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
